import smtplib
import TextToSpeech
import sys
import time
import os
cwd = os.getcwd()

directory = ""
madLibType = ""


def getFile():
    choice = input("\nWould you like to create a madlib about pizza, apples, or thanksgiving?\n-> ").lower()
    while True:
        if choice.__contains__("apple"):
            return "Apples"
            break
        elif choice.__contains__("pizza"):
            return "Pizza"
            break
        elif choice.__contains__("thanks"):
            return "Thanksgiving"
            break
        else:
            choice = input("\nSorry, I don't understand, choose between a madlib about pizza, apples, or thanksgiving.\n-> ")


def findWord(input, index=False):
    frontIndex = input.index("<")

    if not index:
        output = input[frontIndex:]
        rearIndex = output.index(">")
        output = str(output[:rearIndex + 1])
        output = output.replace("<", "").replace(">", "")
        return output
    else:
        return frontIndex
        return rearIndex


def checkIfPlural(input):
    input = str(input)
    index = len(input) - 1
    if input[index:] == "s":
        return True
    else:
        return False


def checkVowel(input):
    input = str(input)
    input = input[:1]
    if input == "a" or input == "e" or input == "i" or input == "o" or input == "u":
        return True
    else:
        return False

def getSingular(input):
    input = str(input)
    index = len(input) - 1
    return str(input[:index])


def getAdjectiveQuestion(input):
    if checkVowel(input):
        return "Please enter an " + input
    else:
        return "Please enter a " + input

def sendMail(messageInput):
    email = input("\nPlease enter your email address\n-> ")

    server = smtplib.SMTP('smtp.gmail.com', 587)
    server.starttls()
    server.login('autosendpy@gmail.com', 'oUUgw3Zp95MWDzWX9U0u0UtSl')
    message = messageInput
    sender = 'autosendpy@gmail.com'
    reciever = email
    server.send
    server.sendmail(sender, reciever, message)
    print("\nEmail sent successfully!")

    server.close()

def saveType():
    choice = input("Would you like your Madlib saved locally, or have it emailed to you?\n-> ").lower()
    while True:
        if choice.__contains__("local") or choice.__contains__("here"):
            choice = "l"
            break
        elif choice.__contains__("email") or choice.__contains__("sent") or choice.__contains__("send"):
            choice = "e"
            break
        else:
            choice = input("\nSorry, I don't understand. Would you like your Madlib saved" +
                  " locally, or would you liked it emailed to you?\n-> ")
    return choice

def textToSpeech(localDir, typeMadLib):
    tts = open(cwd+"/MadLib/" + typeMadLib + "Final.txt", 'r+')
    lineList = tts.readlines()
    listLength = int(100 / len(lineList))
    listIndex = 0

    while listIndex < len(lineList):
        line = lineList[listIndex]
        TextToSpeech.textToSpeech(line, str(listIndex + 1))
        listIndex += 1
        sys.stdout.write("\rDownloading: %d" % (listLength * listIndex) + "%")
        time.sleep(0.2)
        sys.stdout.flush()

    time.sleep(0.2)
    sys.stdout.write("\rDownloaded!: 100%")
    max = listIndex + 1
    listIndex = 2

    file = open(cwd+"/Audio/" + typeMadLib + ".mp3", "wb+")
    fileContent = ""
    concatFile = open(cwd+"/Audio/response1.mp3", "rb").read()
    fileContent = concatFile
    while listIndex < max:
        tempFile = open(cwd+"/Audio/response" + str(listIndex) + ".mp3", "rb").read()
        fileContent += tempFile
        listIndex += 1
    file.write(fileContent)
    print("\nFile was written to the directory:"+cwd+"/Audio/" + typeMadLib + ".mp3")
    file.close()


def main():
    print("Welcome to MadLib maker!")
    time.sleep(0.2)
    madLibType = getFile()
    directory = cwd+"/MadLib/" + madLibType

    customDir = input("Would you like to save to a custom directory?\n-> ").lower()
    if customDir.__contains__('y'):
        directory = input("\nPlease enter the directory you would like to save to: ")
        while not directory:
            directory = input("\nDirectory not valid. Please enter a new directory: ")


    file = open(cwd+"/MadLib/" + madLibType + ".txt", "r+")
    modFile = open(directory + "Final.txt", 'w+')

    lines = file.readlines()
    sentenceNum = 0

    while sentenceNum < len(lines):
        line = lines[sentenceNum]
        while line.__contains__("<"):
            word = findWord(line)
            question = getAdjectiveQuestion(word)
            response = input(question + ": ")
            line = line.replace("<" + word + ">", response)
        modFile.write(line)
        sentenceNum += 1



    save = saveType()
    if save == "l":
        print("\nFile \"" + modFile.name + "\" was saved to the directory ~" + directory)
        modFile.close()
    elif save == "e":
        modFile.close()
        with open(directory + "Final.txt", 'r+') as content_file:
            content = content_file.read()
        sendMail(content)


    listen = input("\nWould you like to hear your Madlib read back to you?\n-> ").lower()
    if listen.__contains__("y"):
        textToSpeech(directory, madLibType)
    else:
        print("Ok, goodbye!")

if __name__ == "__main__":
    main()
