from def_1 import *
from def_2 import *

title = input("Title: ")
key = input("Key: ")
tempo = int(input("Tempo: "))
timeSign = input("Times Signature (4/4, 6/8, etc.): ")
songLen = int(input("Number of Measures: "))
scale = getScale(key)
noteLen = setNoteLen(timeSign,tempo)
measureSum = getMeasureSum(timeSign, tempo)
rhythms = getRhythms(measureSum, songLen, noteLen)
pitches = getPitches(rhythms,scale)
samples = None
for i in range(len(pitches)):
    freq = pitches[i]
    time = rhythms[i]
    c1 = [damped_wave(freq,length=time)]
    c2 = [damped_wave(freq,length=time)]
    channels = [c1,c2]
    sample = compute_samples(channels,nsamples=int(44100*time))
    if samples == None:
        samples = sample
    else:
        samples = chain(samples,sample)
write_wavefile("song.wav",samples,nframes=44100)