from pandas_datareader import data as pdr
import fix_yahoo_finance
import matplotlib.pyplot as plt
import datetime


ticker = input("Please Insert Stock Ticker: ")

yearA = int(input('Start date year (i.e. 2000): '))
monthA = int(input('Start date month (i.e. August = 8): '))
dayA = int(input('Start date day (i.e. 29): '))
start = datetime.datetime(yearA, monthA, dayA)

yearB = int(input('End date year (i.e. 2017): '))
monthB = int(input('End date month (i.e. August = 8): '))
dayB = int(input('End date day (i.e. 2): '))
end = datetime.datetime(yearB, monthB, dayB)

df = pdr.get_data_yahoo(ticker, start, end)

print('Start Day Statistics: ')
print(df.head(1))
print('  End Day Statistics: ')
print(df.tail(1))



df['High'].plot()
plt.legend()
plt.show()
