import pylab
import numpy
import math

def population(humanpop1, humanpop2, factor):
    print('This function will determine how many years it will take for the population given to be increased by a factor of', factor)
    Poprate = (humanpop2 - humanpop1) / humanpop1
    print('Growth rate =', Poprate,'%')
    TheResult = numpy.log(factor) / (Poprate / 100)
    x = numpy.linspace(0, TheResult, 100)
    y = humanpop2 * (math.e)** ((Poprate / 100) * x)
    pylab.xlabel('Years')
    pylab.ylabel('Population')
    pylab.plot(x,y)
    pylab.show()
    print('It will take', TheResult, 'years for the population to be increased by a factor of', factor)
    return

def popwithrate(humanpop, rate, factor):
    print('This function will determine how many years it will take for the population given to be increased by a factor of', factor)
    TheResult = numpy.log(factor) / (rate / 100)
    x = numpy.linspace(0, TheResult, 100)
    y = humanpop * (math.e)** ((rate / 100) * x)
    pylab.xlabel('Years')
    pylab.ylabel('Population')
    pylab.plot(x,y)
    pylab.show()
    print('It will take', TheResult, 'years for the population given to be increased by a factor of', factor)
    return


humanpop1 = int(input('Human Population 1'))
humanpop2 = int(input('Human Population 2'))
factor = int(input('Factor'))

population(humanpop1, humanpop2, factor)